unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure SetNumLock(bState:Boolean);
var
  KeyState : TKeyboardState;
begin
  GetKeyboardState(KeyState);
  if ((bState) and (not ((KeyState[VK_NUMLOCK] and 1)=1) ) or ( (not (bState)) and ((KeyState[VK_NUMLOCK] and 1)=1))) then
  // Simulate a key press
  keybd_event(VK_NUMLOCK, $45, (KEYEVENTF_EXTENDEDKEY or 0), 0);
  // Simulate a key release
  keybd_event( VK_NUMLOCK, $45, (KEYEVENTF_EXTENDEDKEY or KEYEVENTF_KEYUP), 0);
end;

procedure SetCapsLock(bState:Boolean);
var
  KeyState : TKeyboardState;
begin
  GetKeyboardState(KeyState);
  if ((bState) and (not ((KeyState[VK_CAPITAL] and 1)=1) ) or ( (not (bState)) and ((KeyState[VK_CAPITAL] and 1)=1))) then
  // Simulate a key press
  keybd_event(VK_CAPITAL, $45, (KEYEVENTF_EXTENDEDKEY or 0), 0);
  // Simulate a key release
  keybd_event( VK_CAPITAL, $45, (KEYEVENTF_EXTENDEDKEY or KEYEVENTF_KEYUP), 0);
end;

procedure SetScrollLock(bState:Boolean);
var
  KeyState : TKeyboardState;
begin
  GetKeyboardState(KeyState);
  if ((bState) and (not ((KeyState[VK_SCROLL] and 1)=1) ) or ( (not (bState)) and ((KeyState[VK_SCROLL] and 1)=1))) then
  // Simulate a key press
  keybd_event(VK_SCROLL, $45, (KEYEVENTF_EXTENDEDKEY or 0), 0);
  // Simulate a key release
  keybd_event( VK_SCROLL, $45, (KEYEVENTF_EXTENDEDKEY or KEYEVENTF_KEYUP), 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SetNumLock(true);
  SetCapsLock(true);
  SetScrollLock(true);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  SetNumLock(false);
  SetCapsLock(false);
  SetScrollLock(false);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  case Timer1.Tag of
    0:
      begin
        SetNumLock(true);
        SetCapsLock(false);
        SetScrollLock(false);
        Timer1.Tag := 1;
      end;
    1:
      begin
        SetNumLock(false);
        SetCapsLock(true);
        SetScrollLock(false);
        Timer1.Tag := 2;
      end;
    2:
      begin
        SetNumLock(false);
        SetCapsLock(false);
        SetScrollLock(true);
        Timer1.Tag := 0;
      end;
  end;
end;

end.
 